/* ***************
// orkutbar.js
// Orkut Toolbar main JS file.
//
// Author: Renato Rodrigues (rraver.sp@gmail.com)
//
// Uses code from BBCode by Jed Brown 
// <http://jedbrown.net/mozilla/>
//
****************** */

var theBox, startPos, endPos, otbcode_stringBundle, preferencesService;

var otbcode = {
	init: function() {
		otbcode_stringBundle = document.getElementById("otbstrings");
		if (navigator.vendor != "Firefox"){ // Little hack for Mozilla Suite
			document.getElementById("SearchSplitter").setAttribute("height", "24px");			
		};
		preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		otb_iconSize = preferencesService.getIntPref("otb.opt.iconsize");
		if (otb_iconSize == '1') { document.getElementById("orkut-toolbar").setAttribute("iconsize","big"); }
		else { document.getElementById("orkut-toolbar").setAttribute("iconsize","small"); }
	},
  
	otbShowHide: function() {
		var bar=document.getElementById("orkut-toolbar");
		var btnShow=document.getElementById("btn_otbShow");
		bar.setAttribute("collapsed",!bar.collapsed);
		btnShow.setAttribute("collapsed",!btnShow.collapsed);
	},

	promptWindow: function (promptString, initialValue){
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var result = {value:initialValue};
		promptService.prompt(null, "Orkut Toolbar", promptString, result, null, {value:0});		
		
		if (result && result.value != initialValue) { return result.value; }
		else { return null; }
	},

   otbcode: function(myCommand, codeType) {
	    var str = null;
	    theBox = document.commandDispatcher.focusedElement;
    	var oPosition = theBox.scrollTop;
		var oHeight = theBox.scrollHeight;
    
    	//Get Selected text (if selected)
		startPos = theBox.selectionStart;
    	endPos = theBox.selectionEnd;
	    str = theBox.value.substring(startPos, endPos);

		str_clipboard = null

		if(codeType == "otbcode") { otbcode.insertAtCursorSetup(myCommand, str_clipboard, str, theBox); }
		else if(codeType == "otbcode-color") { otbcode.insertAtCursorSetup('color', myCommand, str, theBox); }
		else if(codeType == "otbcode-insert") { otbcode.insertAtCursor(theBox, myCommand); }
		else{ alert("CodeType not defined !"); }

		var nHeight = theBox.scrollHeight - oHeight;
	    theBox.scrollTop = oPosition + nHeight;
	},
  
    insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place

    switch (myCommand){
      case "bold":
			otbcode.insertAtCursor(theBox,"[b]" + str + "[/b]",3);
			break;
      case "italic":
			otbcode.insertAtCursor(theBox,"[i]" + str + "[/i]",3);
			break;
      case "underline":
			otbcode.insertAtCursor(theBox,"[u]" + str + "[/u]",3);
			break;
      case "color":
			otbcode.insertAtCursor(theBox,"[" + str_clipboard + "]" + str + "[/" + str_clipboard + "]",(2 + str_clipboard.length));
			break;
      case "linkABC":
			if (!str) { 
				linkTitle = otbcode_stringBundle.getString("otbcode.linkTitle");
				str = otbcode.promptWindow(linkTitle, ""); 
			}
			if (str) { 
				linkText = otbcode_stringBundle.getString("otbcode.linkABC");
				str_link = otbcode.promptWindow(linkText, "http://");
				if (str_link) { otbcode.insertAtCursor(theBox,"[link=" + str_link + "]" + str + "[/link]",7+str_link.length); }
			}
			break;
      case "linkWWW":
  			if (!str) { 
				linkText = otbcode_stringBundle.getString("otbcode.linkWWW");
				str = otbcode.promptWindow(linkText, "http://");
			}
			if (str) { otbcode.insertAtCursor(theBox,"[link]" + str + "[/link]",6); }
			break;
      case "otbSign":
			otbSign = otbcode_stringBundle.getString("otbcode.otbSign");
			otbcode.insertAtCursor(theBox,otbSign);
			break;
      default : 
        alert("Error #2"); }
},

  //Thanks to Nick for pointing out this function
  insertAtCursor: function(theBox, aText, len) {
    try {
      var command = "cmd_insertText";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        params.setStringValue("state_data", aText);
        controller.doCommandWithParams(command, params);
		theBox.selectionStart = startPos + len; 
 		theBox.selectionEnd = endPos + len; 
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  },
} 

window.addEventListener('load', otbcode.init, false); //Make sure otbcode loads on start-up of browser.

// Must be optimzed

function goURL(url) {
	const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    if(preferencesService.prefHasUserValue("otb.opt.openin")) { OpenIn = preferencesService.getComplexValue("otb.opt.openin", Components.interfaces.nsISupportsString); } else { OpenIn = "newTab"; };

	if (OpenIn=="sameWindow") { window._content.document.location=url; }
	else if (OpenIn=="newWindow") { window.open(url); }
	else {
		var newTab = window.getBrowser().addTab(url);
		window.getBrowser().selectedTab = newTab;
	}
}

function otb_Search(element, SearchType, event) {
    if(SearchType != 'clear') {
        var Criteria = document.getElementById(element);
 		if (SearchType == 'Communities') { goURL('http://www.orkut.com/CommunitySearch.aspx?q=' + Criteria.value + '&lang=all'); }
		else if (SearchType == 'Friends') { goURL('http://www.orkut.com/FriendsFind.aspx?q=' + Criteria.value); }
        otb_addtoSearchHistory(element, Criteria.value); }
	else { otb_clearSearchHistory(element) }
}

function otb_addtoSearchHistory(element, term) {
    var Criteria = document.getElementById(element);
    var historyMenu = Criteria.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;
    var alreadyInHist = false;
    var i = 0;

    for (i = 0; i < numHistItems; i++) { if (term == historyMenu.childNodes[i].getAttribute("label")) { alreadyInHist = true; } }

    if (!alreadyInHist) {
        var myMenuItem = document.createElement("menuitem");
		var maxHistCnt = 10
        myMenuItem.setAttribute("label", term);
//        myMenuItem.setAttribute("oncommand", "Orkut Search Command must be here");

        if (numHistItems <= 0) { historyMenu.appendChild(myMenuItem); }
        else { historyMenu.insertBefore(myMenuItem, historyMenu.childNodes[0]); }

        numHistItems++;

        if (numHistItems > maxHistCnt) { 
			var numToRemove = numHistItems - maxHistCnt;
            for (i = 1; i <= numToRemove; i++) { historyMenu.removeChild(historyMenu.lastChild); }
        }
    }
}

function otb_clearSearchHistory(element) {
    var Criteria = document.getElementById(element);
    if (!Criteria) {
      mainDoc = top.opener.document;
      Criteria = mainDoc.getElementById(element); }
    if (!Criteria) alert("Can't Clear");

    var historyMenu = Criteria.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;

	for (var i = numHistItems - 1; i >= 0; i--) { historyMenu.removeChild(historyMenu.childNodes[i]); }
    Criteria.selectedIndex = -1;
}
