function otb_displaySigMenu(menu){ // Displays the signature switcher menu
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var description           = null;     var descriptionPreference = null;
    var signature             = null;     var signaturePreference   = null;
    var menuItem              = null;     var optionsSeparator      = null;
	var signatureCount        = 0;

    // If the signatures count preference is set
    if(preferencesService.prefHasUserValue("otb.singatures.count")) { signatureCount = preferencesService.getIntPref("otb.singatures.count"); }

    if(menu.getAttribute("id") == "otb-popup-menu") 
		{ optionsSeparator = menu.getElementsByAttribute("id", "otb-separatorsig-menu")[0]; }
    else 
		{ optionsSeparator = menu.getElementsByAttribute("id", "otb-separatorsig-toolbar")[0]; }

	otb_removeSigMenuItems(menu, optionsSeparator);

	for(var i = 1; i <= signatureCount; i++) {     // Loop through the possible signatures
		description = "otb.opt.sig." + i + ".description";
	    signature   = "otb.opt.sig." + i + ".signature";

        if(preferencesService.prefHasUserValue(description) && preferencesService.prefHasUserValue(signature)) { // If the description is set
	        descriptionPreference = preferencesService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
   	        signaturePreference = preferencesService.getComplexValue(signature, Components.interfaces.nsISupportsString).data.trim();

			menuItem = document.createElement("menuitem");
            menuItem.setAttribute("label", descriptionPreference);
            menuItem.setAttribute("tooltiptext", descriptionPreference);
            menuItem.setAttribute("oncommand", "otbcode.otbcode('" + otb_escapeChars(signaturePreference) + "', 'otbcode-insert');");
            menuItem.setAttribute("custom", "true");

			if(menu && optionsSeparator) { menu.insertBefore(menuItem, optionsSeparator); }  // If the menu, menu item and options separator exist
        }
	}
    if(signatureCount > 0) 	{ optionsSeparator.setAttribute("hidden","false") }
}

function otb_removeSigMenuItems(menu,separator) { // Removes all the generated menu items from the menu
    var menuItem       = null;
    var customMenuItems = menu.getElementsByAttribute("custom", "true");

    for(var i = 0; i < customMenuItems.length; i++)  {    // Loop through the custom menu items
        menuItem = customMenuItems[i];
        menu.removeChild(menuItem);
    }

    customMenuItems = menu.getElementsByAttribute("custom", "true");

    while(customMenuItems.length > 1) {   // Loop through the menu items again because of the change to the behavior of getElementsByAttribute
        menuItem = customMenuItems[1];
 		menu.removeChild(menuItem);
    }
	separator.setAttribute("hidden","true")
}

function otb_ShowOptions() { // Displays the options dialog
    window.openDialog("chrome://orkutbar/content/options/options.xul", "otb-options-dialog", "centerscreen,chrome,modal");
}

function otb_escapeChars(string) { // Escapes all special chars in a string
	if(string) {
		var LookFor = new Array("'","\n");
		var ReplaceBy = new Array("\\'","\\n");
		var ResultString;
		ResultString = string;

		for(var i=0;i<=(LookFor.length-1);i++){ 
			ResultString = ResultString.replace(new RegExp(LookFor[i], "gi"), ReplaceBy[i]);
		};
		return ResultString; }
	else { return ""; };
}

